<?php

namespace App\domain\worldpay;

use Exception;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\URL;

class GeneratePaymentPageAction
{
    public function execute(string $paymentURL, string $paymentOrderId): string
    {
        $hostedUrl = URL::to('/');

        $html = '
            <!DOCTYPE html>
            <html>
            <head>
                <title> My test page </title>
                <script src="https://payments.worldpay.com/resources/hpp/integrations/embedded/js/hpp-embedded-integration-library.js"></script>
            </head>
            <body>
                <h3>This is my test page as a merchant</h3>
                <div id="custom-html" style=" height: 500px; border: 1px solid black;"></div>
                <script type="text/javascript">
                    
                    var customOptions = {
                        url: "' . $paymentURL . '",
                        type: "iframe",
                        inject: "onload",
                        target: "custom-html",
                        accessibility: true,
                        debug: true,
                        language: "en",
                        country: "gb",
                        preferredPaymentMethod: "VISA-SSL",
                        successURL: "' . $hostedUrl . '/api/worldpay/success/' . $paymentOrderId . '",
                        cancelURL: "' . $hostedUrl . '/api/worldpay/cancel/' . $paymentOrderId . '",
                        failureURL: "' . $hostedUrl . '/api/worldpay/failure/' . $paymentOrderId . '",
                        errorURL: "' . $hostedUrl . '/api/worldpay/error/' . $paymentOrderId . '"
                    };
                    
                    var libraryObject = new WPCL.Library();
                    libraryObject.setup(customOptions);
                </script>
            </body>
            </html>';

        return $html;
    }

    // successURL: "http://127.0.0.1:8001/worldpay/success",
    // cancelURL: "http://127.0.0.1:8001/worldpay/cancel",
    // failureURL: "http://127.0.0.1:8001/worldpay/failure",
    // pendingURL: "http://127.0.0.1:8001/worldpay/pending",
    // errorURL: "http://127.0.0.1:8001/worldpay/error"
}
